
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Attack_map_eventsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const attack_map_events = await db.attack_map_events.create(
            {
                id: data.id || undefined,
        
        occurred_at: data.occurred_at
        ||
        null
            ,
            
        event_kind: data.event_kind
        ||
        null
            ,
            
        source_country: data.source_country
        ||
        null
            ,
            
        source_ip: data.source_ip
        ||
        null
            ,
            
        destination_country: data.destination_country
        ||
        null
            ,
            
        destination_ip: data.destination_ip
        ||
        null
            ,
            
        latitude: data.latitude
        ||
        null
            ,
            
        longitude: data.longitude
        ||
        null
            ,
            
        risk_score: data.risk_score
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await attack_map_events.setIndicator( data.indicator || null, {
            transaction,
        });
        
        await attack_map_events.setOrganizations( data.organizations || null, {
            transaction,
        });
        

        

        

        return attack_map_events;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const attack_map_eventsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                occurred_at: item.occurred_at
            ||
            null
            ,
            
                event_kind: item.event_kind
            ||
            null
            ,
            
                source_country: item.source_country
            ||
            null
            ,
            
                source_ip: item.source_ip
            ||
            null
            ,
            
                destination_country: item.destination_country
            ||
            null
            ,
            
                destination_ip: item.destination_ip
            ||
            null
            ,
            
                latitude: item.latitude
            ||
            null
            ,
            
                longitude: item.longitude
            ||
            null
            ,
            
                risk_score: item.risk_score
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const attack_map_events = await db.attack_map_events.bulkCreate(attack_map_eventsData, { transaction });

        // For each item created, replace relation files
        

        return attack_map_events;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const attack_map_events = await db.attack_map_events.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.occurred_at !== undefined) updatePayload.occurred_at = data.occurred_at;
        
        
        if (data.event_kind !== undefined) updatePayload.event_kind = data.event_kind;
        
        
        if (data.source_country !== undefined) updatePayload.source_country = data.source_country;
        
        
        if (data.source_ip !== undefined) updatePayload.source_ip = data.source_ip;
        
        
        if (data.destination_country !== undefined) updatePayload.destination_country = data.destination_country;
        
        
        if (data.destination_ip !== undefined) updatePayload.destination_ip = data.destination_ip;
        
        
        if (data.latitude !== undefined) updatePayload.latitude = data.latitude;
        
        
        if (data.longitude !== undefined) updatePayload.longitude = data.longitude;
        
        
        if (data.risk_score !== undefined) updatePayload.risk_score = data.risk_score;
        
        
        updatePayload.updatedById = currentUser.id;

        await attack_map_events.update(updatePayload, {transaction});

        
        
        if (data.indicator !== undefined) {
            await attack_map_events.setIndicator(
              
              data.indicator,
              
              { transaction }
            );
        }
        
        if (data.organizations !== undefined) {
            await attack_map_events.setOrganizations(
              
              data.organizations,
              
              { transaction }
            );
        }
        

        
        

        

        return attack_map_events;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const attack_map_events = await db.attack_map_events.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of attack_map_events) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of attack_map_events) {
                await record.destroy({transaction});
            }
        });


        return attack_map_events;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const attack_map_events = await db.attack_map_events.findByPk(id, options);

        await attack_map_events.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await attack_map_events.destroy({
            transaction
        });

        return attack_map_events;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const attack_map_events = await db.attack_map_events.findOne(
            { where },
            { transaction },
        );

        if (!attack_map_events) {
            return attack_map_events;
        }

        const output = attack_map_events.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.indicator = await attack_map_events.getIndicator({
            transaction
        });
        
        
        output.organizations = await attack_map_events.getOrganizations({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.threat_indicators,
        as: 'indicator',
        
        where: filter.indicator ? {
          [Op.or]: [
            { id: { [Op.in]: filter.indicator.split('|').map(term => Utils.uuid(term)) } },
            {
              indicator_value: {
                [Op.or]: filter.indicator.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.organizations,
        as: 'organizations',
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.source_country) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'attack_map_events',
                        'source_country',
                        filter.source_country,
                    ),
                };
            }
            
            if (filter.source_ip) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'attack_map_events',
                        'source_ip',
                        filter.source_ip,
                    ),
                };
            }
            
            if (filter.destination_country) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'attack_map_events',
                        'destination_country',
                        filter.destination_country,
                    ),
                };
            }
            
            if (filter.destination_ip) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'attack_map_events',
                        'destination_ip',
                        filter.destination_ip,
                    ),
                };
            }
            

            
            

            
            if (filter.occurred_atRange) {
                const [start, end] = filter.occurred_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    occurred_at: {
                    ...where.occurred_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    occurred_at: {
                    ...where.occurred_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.latitudeRange) {
                const [start, end] = filter.latitudeRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    latitude: {
                    ...where.latitude,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    latitude: {
                    ...where.latitude,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.longitudeRange) {
                const [start, end] = filter.longitudeRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    longitude: {
                    ...where.longitude,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    longitude: {
                    ...where.longitude,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.risk_scoreRange) {
                const [start, end] = filter.risk_scoreRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    risk_score: {
                    ...where.risk_score,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    risk_score: {
                    ...where.risk_score,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.event_kind) {
                where = {
                    ...where,
                event_kind: filter.event_kind,
            };
            }
            


      

      
      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationsId: {[Op.or]: listItems}
        };
      }
      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.attack_map_events.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'attack_map_events',
                        'source_ip',
                        query,
                    ),
                ],
            };
        }

        const records = await db.attack_map_events.findAll({
            attributes: [ 'id', 'source_ip' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['source_ip', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.source_ip,
        }));
    }

    
};

